]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
Merge branch 'jc/rebase-in-c-5-test-typofix'
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 17OPTIONS_SPEC=
091a6eb0 18SUBDIRECTORY_OK=Yes
70c7ac22 19. git-sh-setup
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
f1762d77
BW
25# Tell the rest of git that any URLs we get don't come
26# directly from the user, so it can apply policy as appropriate.
27GIT_PROTOCOL_FROM_USER=0
28export GIT_PROTOCOL_FROM_USER
33cfccbb 29
5c08dbbd 30command=
ecda0723 31branch=
d27b876b 32force=
d92a3959 33reference=
70c7ac22 34cached=
48bb3033
GP
35recursive=
36init=
1c244f6e 37files=
06b1abb5 38remote=
31ca3ac3 39nofetch=
32948425 40update=
15fc56a8 41prefix=
73b0898d 42custom_name=
275cd184 43depth=
72c5f883 44progress=
a0ef2934 45dissociate=
70c7ac22 46
be9d0a3a
HV
47die_if_unmatched ()
48{
49 if test "$1" = "#unmatched"
50 then
c4c02bf1 51 exit ${2:-1}
be9d0a3a
HV
52 fi
53}
54
88ce00c3
TK
55#
56# Print a submodule configuration setting
57#
58# $1 = submodule name
59# $2 = option name
60# $3 = default value
61#
62# Checks in the usual git-config places first (for overrides),
63# otherwise it falls back on .gitmodules. This allows you to
64# distribute project-wide defaults in .gitmodules, while still
65# customizing individual repositories if necessary. If the option is
66# not in .gitmodules either, print a default value.
67#
68get_submodule_config () {
69 name="$1"
70 option="$2"
71 default="$3"
72 value=$(git config submodule."$name"."$option")
73 if test -z "$value"
74 then
75 value=$(git config -f .gitmodules submodule."$name"."$option")
76 fi
77 printf '%s' "${value:-$default}"
78}
79
862ae6cd
RS
80isnumber()
81{
82 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
83}
84
dda63468 85# Given a full hex object ID, is this the zero OID?
86is_zero_oid () {
87 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
88}
89
14111fc4
JK
90# Sanitize the local git environment for use within a submodule. We
91# can't simply use clear_local_git_env since we want to preserve some
92# of the settings from GIT_CONFIG_PARAMETERS.
93sanitize_submodule_env()
94{
89044baa 95 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 96 clear_local_git_env
89044baa 97 GIT_CONFIG_PARAMETERS=$save_config
860cba61 98 export GIT_CONFIG_PARAMETERS
14111fc4
JK
99}
100
ecda0723
SV
101#
102# Add a new submodule to the working tree, .gitmodules and the index
103#
ec05df35 104# $@ = repo path
ecda0723
SV
105#
106# optional branch is stored in global branch variable
107#
23a485e3 108cmd_add()
ecda0723 109{
5c08dbbd 110 # parse $args after "submodule ... add".
091a6eb0 111 reference_path=
5c08dbbd
JH
112 while test $# -ne 0
113 do
114 case "$1" in
115 -b | --branch)
116 case "$2" in '') usage ;; esac
117 branch=$2
118 shift
119 ;;
d27b876b
JL
120 -f | --force)
121 force=$1
122 ;;
5c08dbbd 123 -q|--quiet)
2e6a30ef 124 GIT_QUIET=1
5c08dbbd 125 ;;
6d33e1c2
CF
126 --progress)
127 progress=1
128 ;;
d92a3959
MT
129 --reference)
130 case "$2" in '') usage ;; esac
091a6eb0 131 reference_path=$2
d92a3959
MT
132 shift
133 ;;
134 --reference=*)
091a6eb0 135 reference_path="${1#--reference=}"
d92a3959 136 ;;
a0ef2934
CF
137 --dissociate)
138 dissociate=1
139 ;;
73b0898d
JL
140 --name)
141 case "$2" in '') usage ;; esac
142 custom_name=$2
143 shift
144 ;;
275cd184
FG
145 --depth)
146 case "$2" in '') usage ;; esac
147 depth="--depth=$2"
148 shift
149 ;;
150 --depth=*)
151 depth=$1
152 ;;
5c08dbbd
JH
153 --)
154 shift
155 break
156 ;;
157 -*)
158 usage
159 ;;
160 *)
161 break
162 ;;
163 esac
164 shift
165 done
166
091a6eb0
JK
167 if test -n "$reference_path"
168 then
169 is_absolute_path "$reference_path" ||
170 reference_path="$wt_prefix$reference_path"
171
172 reference="--reference=$reference_path"
173 fi
174
ecda0723 175 repo=$1
64394e3a 176 sm_path=$2
ecda0723 177
64394e3a 178 if test -z "$sm_path"; then
6a066230 179 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
180 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
181 fi
182
496eeeb1 183 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
184 usage
185 fi
186
091a6eb0
JK
187 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
188
ec05df35
ML
189 # assure repo is absolute or relative to parent
190 case "$repo" in
191 ./*|../*)
091a6eb0
JK
192 test -z "$wt_prefix" ||
193 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
194
ec05df35 195 # dereference source url relative to parent's url
63e95beb 196 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
197 ;;
198 *:*|/*)
199 # absolute url
200 realrepo=$repo
201 ;;
202 *)
497ee872 203 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
204 ;;
205 esac
206
db75ada5
MG
207 # normalize path:
208 # multiple //; leading ./; /./; /../; trailing /
64394e3a 209 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
210 sed -e '
211 s|//*|/|g
212 s|^\(\./\)*||
8196e728 213 s|/\(\./\)*|/|g
db75ada5
MG
214 :start
215 s|\([^/]*\)/\.\./||
216 tstart
217 s|/*$||
218 ')
619acfc7
SB
219 if test -z "$force"
220 then
221 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
222 die "$(eval_gettext "'\$sm_path' already exists in the index")"
223 else
224 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
225 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
226 fi
ecda0723 227
53213994
JK
228 if test -z "$force" &&
229 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
d27b876b 230 then
6ff875c5 231 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 232\$sm_path
6ff875c5 233Use -f if you really want to add it." >&2
d27b876b
JL
234 exit 1
235 fi
236
73b0898d
JL
237 if test -n "$custom_name"
238 then
239 sm_name="$custom_name"
240 else
241 sm_name="$sm_path"
242 fi
243
0383bbb9
JK
244 if ! git submodule--helper check-name "$sm_name"
245 then
246 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
247 fi
248
d4264ca3 249 # perhaps the path exists and is already a git repo, else clone it
64394e3a 250 if test -e "$sm_path"
d4264ca3 251 then
496eeeb1 252 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 253 then
64394e3a 254 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 255 else
64394e3a 256 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 257 fi
c2f93917 258
d4264ca3 259 else
4b7c286e
JL
260 if test -d ".git/modules/$sm_name"
261 then
262 if test -z "$force"
263 then
0d71dbfd 264 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 265 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
266 die "$(eval_gettextln "\
267If you want to reuse this local git directory instead of cloning again from
268 \$realrepo
269use the '--force' option. If the local git directory is not the correct repo
270or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 271 else
0d71dbfd 272 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
273 fi
274 fi
a0ef2934 275 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
d851ffb9 276 (
14111fc4 277 sanitize_submodule_env
d851ffb9
JH
278 cd "$sm_path" &&
279 # ash fails to wordsplit ${branch:+-b "$branch"...}
280 case "$branch" in
281 '') git checkout -f -q ;;
282 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
283 esac
284 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 285 fi
73b0898d 286 git config submodule."$sm_name".url "$realrepo"
d4264ca3 287
53213994 288 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 289 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 290
73b0898d
JL
291 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
292 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
293 if test -n "$branch"
294 then
295 git config -f .gitmodules submodule."$sm_name".branch "$branch"
296 fi &&
31991b02 297 git add --force .gitmodules ||
64394e3a 298 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
299
300 # NEEDSWORK: In a multi-working-tree world, this needs to be
301 # set in the per-worktree config.
302 if git config --get submodule.active >/dev/null
303 then
304 # If the submodule being adding isn't already covered by the
305 # current configured pathspec, set the submodule's active flag
306 if ! git submodule--helper is-active "$sm_path"
307 then
308 git config submodule."$sm_name".active "true"
309 fi
310 else
311 git config submodule."$sm_name".active "true"
312 fi
ecda0723
SV
313}
314
19a31f9c
ML
315#
316# Execute an arbitrary command sequence in each checked out
317# submodule
318#
319# $@ = command to execute
320#
321cmd_foreach()
322{
1d5bec8b
JH
323 # parse $args after "submodule ... foreach".
324 while test $# -ne 0
325 do
326 case "$1" in
327 -q|--quiet)
328 GIT_QUIET=1
329 ;;
15fc56a8
JH
330 --recursive)
331 recursive=1
332 ;;
1d5bec8b
JH
333 -*)
334 usage
335 ;;
336 *)
337 break
338 ;;
339 esac
340 shift
341 done
342
fc1b9243 343 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
19a31f9c
ML
344}
345
70c7ac22 346#
211b7f19 347# Register submodules in .git/config
70c7ac22
LH
348#
349# $@ = requested paths (default to all)
350#
23a485e3 351cmd_init()
70c7ac22 352{
5c08dbbd
JH
353 # parse $args after "submodule ... init".
354 while test $# -ne 0
355 do
356 case "$1" in
357 -q|--quiet)
2e6a30ef 358 GIT_QUIET=1
5c08dbbd
JH
359 ;;
360 --)
361 shift
362 break
363 ;;
364 -*)
365 usage
366 ;;
367 *)
368 break
369 ;;
370 esac
371 shift
372 done
373
6e7c14e6 374 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
375}
376
cf419828
JL
377#
378# Unregister submodules from .git/config and remove their work tree
379#
cf419828
JL
380cmd_deinit()
381{
382 # parse $args after "submodule ... deinit".
f6a52799 383 deinit_all=
cf419828
JL
384 while test $# -ne 0
385 do
386 case "$1" in
387 -f|--force)
388 force=$1
389 ;;
390 -q|--quiet)
391 GIT_QUIET=1
392 ;;
f6a52799
SB
393 --all)
394 deinit_all=t
395 ;;
cf419828
JL
396 --)
397 shift
398 break
399 ;;
400 -*)
401 usage
402 ;;
403 *)
404 break
405 ;;
406 esac
407 shift
408 done
409
2e612731 410 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
cf419828
JL
411}
412
fb43e31f 413is_tip_reachable () (
01e1d544 414 sanitize_submodule_env &&
fb43e31f
SB
415 cd "$1" &&
416 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
417 test -z "$rev"
418)
419
420fetch_in_submodule () (
01e1d544 421 sanitize_submodule_env &&
fb43e31f
SB
422 cd "$1" &&
423 case "$2" in
424 '')
425 git fetch ;;
426 *)
6cbf454a
SB
427 shift
428 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
429 esac
430)
431
70c7ac22 432#
211b7f19 433# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
434#
435# $@ = requested paths (default to all)
436#
23a485e3 437cmd_update()
70c7ac22 438{
5c08dbbd
JH
439 # parse $args after "submodule ... update".
440 while test $# -ne 0
441 do
442 case "$1" in
443 -q|--quiet)
2e6a30ef 444 GIT_QUIET=1
5c08dbbd 445 ;;
e84c3cf3
SB
446 -v)
447 GIT_QUIET=0
448 ;;
72c5f883 449 --progress)
c7199e3a 450 progress=1
72c5f883 451 ;;
be4d2c83 452 -i|--init)
d92a3959 453 init=1
be4d2c83 454 ;;
06b1abb5
TK
455 --remote)
456 remote=1
457 ;;
31ca3ac3 458 -N|--no-fetch)
31ca3ac3
FF
459 nofetch=1
460 ;;
9db31bdf
NMC
461 -f|--force)
462 force=$1
463 ;;
ca2cedba 464 -r|--rebase)
32948425 465 update="rebase"
ca2cedba 466 ;;
d92a3959
MT
467 --reference)
468 case "$2" in '') usage ;; esac
469 reference="--reference=$2"
98dbe63d 470 shift
d92a3959
MT
471 ;;
472 --reference=*)
473 reference="$1"
d92a3959 474 ;;
a0ef2934
CF
475 --dissociate)
476 dissociate=1
477 ;;
42b49178 478 -m|--merge)
42b49178
JH
479 update="merge"
480 ;;
b13fd5c1 481 --recursive)
b13fd5c1
JH
482 recursive=1
483 ;;
efc5fb6a
JH
484 --checkout)
485 update="checkout"
486 ;;
abed000a
SB
487 --recommend-shallow)
488 recommend_shallow="--recommend-shallow"
489 ;;
490 --no-recommend-shallow)
491 recommend_shallow="--no-recommend-shallow"
492 ;;
275cd184
FG
493 --depth)
494 case "$2" in '') usage ;; esac
495 depth="--depth=$2"
496 shift
497 ;;
498 --depth=*)
499 depth=$1
500 ;;
2335b870
SB
501 -j|--jobs)
502 case "$2" in '') usage ;; esac
503 jobs="--jobs=$2"
504 shift
505 ;;
506 --jobs=*)
507 jobs=$1
508 ;;
5c08dbbd
JH
509 --)
510 shift
511 break
512 ;;
513 -*)
514 usage
515 ;;
516 *)
517 break
518 ;;
519 esac
98dbe63d 520 shift
5c08dbbd
JH
521 done
522
d92a3959
MT
523 if test -n "$init"
524 then
525 cmd_init "--" "$@" || return
526 fi
527
48308681
SB
528 {
529 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
c7199e3a 530 ${progress:+"--progress"} \
48308681
SB
531 ${wt_prefix:+--prefix "$wt_prefix"} \
532 ${prefix:+--recursive-prefix "$prefix"} \
533 ${update:+--update "$update"} \
5f50f33e 534 ${reference:+"$reference"} \
a0ef2934 535 ${dissociate:+"--dissociate"} \
48308681 536 ${depth:+--depth "$depth"} \
c7199e3a
CF
537 $recommend_shallow \
538 $jobs \
c4c02bf1 539 "$@" || echo "#unmatched" $?
48308681 540 } | {
15ffb7cd 541 err=
9eca701f 542 while read -r quickabort sha1 just_cloned sm_path
70c7ac22 543 do
9eca701f 544 die_if_unmatched "$quickabort" "$sha1"
48308681 545
74d4731d
SB
546 git submodule--helper ensure-core-worktree "$sm_path"
547
ee69b2a9 548 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
efc5fb6a 549
44431df0 550 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 551
48308681 552 if test $just_cloned -eq 1
d851ffb9 553 then
bf2d8246
LH
554 subsha1=
555 else
14111fc4 556 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 557 git rev-parse --verify HEAD) ||
091a6eb0 558 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 559 fi
211b7f19 560
06b1abb5
TK
561 if test -n "$remote"
562 then
92bbe7cc 563 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
564 if test -z "$nofetch"
565 then
566 # Fetch remote before determining tracking $sha1
6cbf454a 567 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
568 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
569 fi
14111fc4
JK
570 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
571 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 572 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 573 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
574 fi
575
496eeeb1 576 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 577 then
9db31bdf
NMC
578 subforce=$force
579 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 580 if test -z "$subsha1" && test -z "$force"
b9b378a0 581 then
9db31bdf 582 subforce="-f"
b9b378a0 583 fi
31ca3ac3
FF
584
585 if test -z "$nofetch"
586 then
e5f522d6
JL
587 # Run fetch only if $sha1 isn't present or it
588 # is not reachable from a ref.
fb43e31f 589 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 590 fetch_in_submodule "$sm_path" $depth ||
e30d8336 591 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
592
593 # Now we tried the usual fetch, but $sha1 may
594 # not be reachable from any of the refs
595 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 596 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 597 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
598 fi
599
877449c1 600 must_die_on_failure=
32948425 601 case "$update_module" in
a2aed08b
TK
602 checkout)
603 command="git checkout $subforce -q"
604 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
605 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
606 ;;
32948425
JH
607 rebase)
608 command="git rebase"
091a6eb0
JK
609 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
610 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 611 must_die_on_failure=yes
32948425 612 ;;
42b49178
JH
613 merge)
614 command="git merge"
091a6eb0
JK
615 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
616 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 617 must_die_on_failure=yes
42b49178 618 ;;
6cb5728c
CP
619 !*)
620 command="${update_module#!}"
b08238ac
SB
621 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
622 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
623 must_die_on_failure=yes
624 ;;
32948425 625 *)
ff03d930 626 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
32948425 627 esac
70c7ac22 628
14111fc4 629 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 630 then
ff968f03 631 say "$say_msg"
877449c1
JH
632 elif test -n "$must_die_on_failure"
633 then
ff968f03 634 die_with_status 2 "$die_msg"
15ffb7cd 635 else
ff968f03 636 err="${err};$die_msg"
877449c1 637 continue
15ffb7cd 638 fi
70c7ac22 639 fi
b13fd5c1
JH
640
641 if test -n "$recursive"
642 then
75bf5e60 643 (
44431df0 644 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 645 wt_prefix=
14111fc4 646 sanitize_submodule_env
75bf5e60 647 cd "$sm_path" &&
36141282 648 eval cmd_update
75bf5e60 649 )
15ffb7cd
FG
650 res=$?
651 if test $res -gt 0
652 then
091a6eb0 653 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 654 if test $res -ne 2
15ffb7cd 655 then
ff968f03 656 err="${err};$die_msg"
15ffb7cd
FG
657 continue
658 else
ff968f03 659 die_with_status $res "$die_msg"
15ffb7cd
FG
660 fi
661 fi
b13fd5c1 662 fi
70c7ac22 663 done
15ffb7cd
FG
664
665 if test -n "$err"
666 then
667 OIFS=$IFS
668 IFS=';'
669 for e in $err
670 do
671 if test -n "$e"
672 then
673 echo >&2 "$e"
674 fi
675 done
676 IFS=$OIFS
677 exit 1
678 fi
679 }
70c7ac22
LH
680}
681
28f9af5d
PY
682#
683# Show commit summary for submodules in index or working tree
684#
685# If '--cached' is given, show summary between index and given commit,
686# or between working tree and given commit
687#
688# $@ = [commit (default 'HEAD'),] requested paths (default all)
689#
690cmd_summary() {
f2dc06a3 691 summary_limit=-1
d0f64dd4 692 for_status=
1c244f6e 693 diff_cmd=diff-index
f2dc06a3 694
28f9af5d
PY
695 # parse $args after "submodule ... summary".
696 while test $# -ne 0
697 do
698 case "$1" in
699 --cached)
700 cached="$1"
701 ;;
1c244f6e
JL
702 --files)
703 files="$1"
704 ;;
d0f64dd4
PY
705 --for-status)
706 for_status="$1"
707 ;;
f2dc06a3 708 -n|--summary-limit)
862ae6cd
RS
709 summary_limit="$2"
710 isnumber "$summary_limit" || usage
f2dc06a3
PY
711 shift
712 ;;
862ae6cd
RS
713 --summary-limit=*)
714 summary_limit="${1#--summary-limit=}"
715 isnumber "$summary_limit" || usage
716 ;;
28f9af5d
PY
717 --)
718 shift
719 break
720 ;;
721 -*)
722 usage
723 ;;
724 *)
725 break
726 ;;
727 esac
728 shift
729 done
bffe71f4 730
f2dc06a3
PY
731 test $summary_limit = 0 && return
732
3deea89c 733 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
734 then
735 head=$rev
caa9c3ca 736 test $# = 0 || shift
496eeeb1 737 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 738 then
14e940d7
JH
739 # before the first commit: compare with an empty tree
740 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 741 test -z "$1" || shift
28f9af5d 742 else
3deea89c 743 head="HEAD"
28f9af5d
PY
744 fi
745
1c244f6e
JL
746 if [ -n "$files" ]
747 then
748 test -n "$cached" &&
465d6a00 749 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
750 diff_cmd=diff-files
751 head=
752 fi
753
28f9af5d 754 cd_to_toplevel
091a6eb0 755 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 756 # Get modified modules cared by user
18076502 757 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 758 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 759 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
760 do
761 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
762 if test "$status" = D || test "$status" = T
763 then
6a066230 764 printf '%s\n' "$sm_path"
496eeeb1
EP
765 continue
766 fi
927b26f8 767 # Respect the ignore setting for --for-status.
768 if test -n "$for_status"
769 then
0ea306ef 770 name=$(git submodule--helper name "$sm_path")
927b26f8 771 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 772 test $status != A && test $ignore_config = all && continue
927b26f8 773 fi
28f9af5d 774 # Also show added or modified modules which are checked out
974ce807 775 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 776 printf '%s\n' "$sm_path"
28f9af5d
PY
777 done
778 )
1cb639e6 779
d0f64dd4
PY
780 test -z "$modules" && return
781
18076502 782 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 783 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 784 cut -c2- |
cf9e55f4 785 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
786 do
787 if test -z "$cached" &&
dda63468 788 is_zero_oid $sha1_dst
1cb639e6
PY
789 then
790 case "$mod_dst" in
791 160000)
792 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
793 ;;
794 100644 | 100755 | 120000)
795 sha1_dst=$(git hash-object $name)
796 ;;
797 000000)
798 ;; # removed
799 *)
800 # unexpected type
6ff875c5 801 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
802 continue ;;
803 esac
804 fi
805 missing_src=
806 missing_dst=
807
808 test $mod_src = 160000 &&
974ce807 809 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
810 missing_src=t
811
812 test $mod_dst = 160000 &&
974ce807 813 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 814 missing_dst=t
bffe71f4 815
44431df0 816 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 817
1cb639e6
PY
818 total_commits=
819 case "$missing_src,$missing_dst" in
820 t,)
091a6eb0 821 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
822 ;;
823 ,t)
091a6eb0 824 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
825 ;;
826 t,t)
091a6eb0 827 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
828 ;;
829 *)
830 errmsg=
831 total_commits=$(
496eeeb1 832 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
833 then
834 range="$sha1_src...$sha1_dst"
835 elif test $mod_src = 160000
836 then
837 range=$sha1_src
838 else
839 range=$sha1_dst
840 fi
841 GIT_DIR="$name/.git" \
b0e621ad 842 git rev-list --first-parent $range -- | wc -l
1cb639e6 843 )
eed35595 844 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
845 ;;
846 esac
847
848 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
849 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
850 if test $status = T
851 then
b3e73449
ÆAB
852 blob="$(gettext "blob")"
853 submodule="$(gettext "submodule")"
1cb639e6
PY
854 if test $mod_dst = 160000
855 then
091a6eb0 856 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 857 else
091a6eb0 858 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
859 fi
860 else
091a6eb0 861 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
862 fi
863 if test -n "$errmsg"
864 then
865 # Don't give error msg for modification whose dst is not submodule
866 # i.e. deleted or changed to blob
867 test $mod_dst = 160000 && echo "$errmsg"
868 else
496eeeb1 869 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 870 then
f2dc06a3
PY
871 limit=
872 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 873 GIT_DIR="$name/.git" \
f2dc06a3 874 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
875 --first-parent $sha1_src...$sha1_dst
876 elif test $mod_dst = 160000
877 then
878 GIT_DIR="$name/.git" \
879 git log --pretty='format: > %s' -1 $sha1_dst
880 else
881 GIT_DIR="$name/.git" \
882 git log --pretty='format: < %s' -1 $sha1_src
883 fi
884 echo
885 fi
886 echo
3ba7407b 887 done
28f9af5d 888}
70c7ac22 889#
941987a5 890# List all submodules, prefixed with:
70c7ac22
LH
891# - submodule not initialized
892# + different revision checked out
893#
894# If --cached was specified the revision in the index will be printed
895# instead of the currently checked out revision.
896#
897# $@ = requested paths (default to all)
898#
23a485e3 899cmd_status()
70c7ac22 900{
5c08dbbd
JH
901 # parse $args after "submodule ... status".
902 while test $# -ne 0
903 do
904 case "$1" in
905 -q|--quiet)
2e6a30ef 906 GIT_QUIET=1
5c08dbbd
JH
907 ;;
908 --cached)
909 cached=1
910 ;;
64b19ffe
JH
911 --recursive)
912 recursive=1
913 ;;
5c08dbbd
JH
914 --)
915 shift
916 break
917 ;;
918 -*)
919 usage
920 ;;
921 *)
922 break
923 ;;
924 esac
925 shift
926 done
927
a9f8a375 928 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
70c7ac22 929}
2327f61e
DA
930#
931# Sync remote urls for submodules
932# This makes the value for remote.$remote.url match the value
933# specified in .gitmodules.
934#
935cmd_sync()
936{
937 while test $# -ne 0
938 do
939 case "$1" in
940 -q|--quiet)
2e6a30ef 941 GIT_QUIET=1
2327f61e
DA
942 shift
943 ;;
82f49f29
PH
944 --recursive)
945 recursive=1
946 shift
947 ;;
2327f61e
DA
948 --)
949 shift
950 break
951 ;;
952 -*)
953 usage
954 ;;
955 *)
956 break
957 ;;
958 esac
959 done
e7849a96 960
13424764 961 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
2327f61e 962}
70c7ac22 963
f6f85861
SB
964cmd_absorbgitdirs()
965{
966 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
967}
968
5c08dbbd
JH
969# This loop parses the command line arguments to find the
970# subcommand name to dispatch. Parsing of the subcommand specific
971# options are primarily done by the subcommand implementations.
972# Subcommand specific options such as --branch and --cached are
973# parsed here as well, for backward compatibility.
974
975while test $# != 0 && test -z "$command"
70c7ac22
LH
976do
977 case "$1" in
f6f85861 978 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 979 command=$1
70c7ac22
LH
980 ;;
981 -q|--quiet)
2e6a30ef 982 GIT_QUIET=1
70c7ac22 983 ;;
ecda0723
SV
984 -b|--branch)
985 case "$2" in
986 '')
987 usage
988 ;;
989 esac
990 branch="$2"; shift
991 ;;
70c7ac22 992 --cached)
28f9af5d 993 cached="$1"
70c7ac22
LH
994 ;;
995 --)
996 break
997 ;;
998 -*)
999 usage
1000 ;;
1001 *)
1002 break
1003 ;;
1004 esac
1005 shift
1006done
1007
5c08dbbd 1008# No command word defaults to "status"
af9c9f97
RR
1009if test -z "$command"
1010then
1011 if test $# = 0
1012 then
1013 command=status
1014 else
1015 usage
1016 fi
1017fi
5c08dbbd
JH
1018
1019# "-b branch" is accepted only by "add"
1020if test -n "$branch" && test "$command" != add
1021then
ecda0723 1022 usage
5c08dbbd
JH
1023fi
1024
28f9af5d 1025# "--cached" is accepted only by "status" and "summary"
496eeeb1 1026if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1027then
70c7ac22 1028 usage
5c08dbbd
JH
1029fi
1030
1031"cmd_$command" "$@"